//+++======================================================================+++
//+++                     Moving Averages 3x3 Colors                       +++
//+++======================================================================+++

#property copyright "  Tankk,  31  december  2015,  http://forexsystems.ru/" 
#property link      "http://forexsystemsru.com/indikatory-foreks/70042-kak-sdelat`-samomu-trendovyi-indikator.html" 

#property description "    :)) :))   Moving Average         ." 
#property description "    :  (), ,   ."
#property description "MA       ,  ,      ."
#property description "  MA,     .   ." 
//#property version   "3.00"

#property indicator_chart_window
#property indicator_buffers 9

enum types { Simple, OpenClose, LowHigh, HeikenAshi };

//+++======================================================================+++
//+++                     Moving Averages 3x3 Colors                       +++
//+++======================================================================+++
extern types   MA123Type  =  Simple;

extern int     MA1period  =  15,           
                MA1shift  =  0;           
extern ENUM_MA_METHOD     MA1metod  =  MODE_LWMA;    
extern ENUM_APPLIED_PRICE MA1price  =  PRICE_CLOSE;   

extern int MA1ColorTime  =  12;                     
extern ENUM_LINE_STYLE MA1style  =  STYLE_SOLID;    
extern int      MA1size  =  0,   
        SizeIndication1  =  3;  //   //  =0 ==  " " :))
extern color    MA1Clr1  =  Lavender,         
                MA1Clr2  =  Gold,           
                MA1Clr3  =  Magenta;            

//+++======================================================================+++
extern int     MA2period  =  60,           
                MA2shift  =  0;           
extern ENUM_MA_METHOD     MA2metod  =  MODE_LWMA;    
extern ENUM_APPLIED_PRICE MA2price  =  PRICE_CLOSE;   

extern int MA2ColorTime  =  48;                     
extern ENUM_LINE_STYLE MA2style  =  STYLE_SOLID;    
extern int      MA2size  =  0,   
        SizeIndication2  =  6;  //   //  =0 ==  " " :))
extern color    MA2Clr1  =  LightSeaGreen,         
                MA2Clr2  =  SlateBlue,           
                MA2Clr3  =  FireBrick;            

//+++======================================================================+++
extern int     MA3period  =  180,           
                MA3shift  =  0;           
extern ENUM_MA_METHOD     MA3metod  =  MODE_LWMA;    
extern ENUM_APPLIED_PRICE MA3price  =  PRICE_CLOSE;   

extern int MA3ColorTime  =  144;                     
extern ENUM_LINE_STYLE MA3style  =  STYLE_SOLID;    
extern int      MA3size  =  0,   
        SizeIndication3  =  9;  //   //  =0 ==  " " :))
extern color    MA3Clr1  =  Lime,         
                MA3Clr2  =  DodgerBlue,           
                MA3Clr3  =  Red;            

     
//+++======================================================================+++
//+++                     Moving Averages 3x3 Colors                       +++
//+++======================================================================+++
double MA1Buffer1[], MA1Buffer2[], MA1Buffer3[];
double MA2Buffer1[], MA2Buffer2[], MA2Buffer3[];
double MA3Buffer1[], MA3Buffer2[], MA3Buffer3[];

//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++
int init()
  {
   SetIndexBuffer(0,MA1Buffer1);   SetIndexBuffer(1,MA1Buffer2);   SetIndexBuffer(2,MA1Buffer3);
   SetIndexBuffer(3,MA2Buffer1);   SetIndexBuffer(4,MA2Buffer2);   SetIndexBuffer(5,MA2Buffer3);
   SetIndexBuffer(6,MA3Buffer1);   SetIndexBuffer(7,MA3Buffer2);   SetIndexBuffer(8,MA3Buffer3);
   
//+++======================================================================+++
   return(0);
  }
  
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++
int start()
  {
   int i, j, shift;
   static int width1=1;   static int width2=1;   static int width3=1;
   
//+++======================================================================+++
   for(i=0; i<Bars-(2*MA1ColorTime+1); i+=MA1ColorTime*3)
     {
      for(j=0, shift=i; j<(MA1ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA1Buffer1[shift] = iMA(NULL,0,MA1period,MA1shift,MA1metod,MA1price,shift);
            
        if (MA123Type == OpenClose)
            MA1Buffer1[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_OPEN,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA1Buffer1[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_LOW,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA1Buffer1[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_OPEN,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_LOW,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA1ColorTime)
               {
                MA1Buffer2[shift]=EMPTY_VALUE;
                MA1Buffer3[shift]=EMPTY_VALUE;
               }
        }
     }

//+++======================================================================+++
   for(i=0; i<Bars-(2*MA2ColorTime+1); i+=MA2ColorTime*3)
     {
      for(j=0, shift=i; j<(MA2ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA2Buffer1[shift] = iMA(NULL,0,MA2period,MA2shift,MA2metod,MA2price,shift);
            
        if (MA123Type == OpenClose)
            MA2Buffer1[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_OPEN,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA2Buffer1[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_LOW,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA2Buffer1[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_OPEN,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_LOW,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA2ColorTime)
               {
                MA2Buffer2[shift]=EMPTY_VALUE;
                MA2Buffer3[shift]=EMPTY_VALUE;
               }
        }
     }
     
//+++======================================================================+++
   for(i=0; i<Bars-(2*MA3ColorTime+1); i+=MA3ColorTime*3)
     {
      for(j=0, shift=i; j<(MA3ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA3Buffer1[shift] = iMA(NULL,0,MA3period,MA3shift,MA3metod,MA3price,shift);
            
        if (MA123Type == OpenClose)
            MA3Buffer1[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_OPEN,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA3Buffer1[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_LOW,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA3Buffer1[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_OPEN,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_LOW,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA3ColorTime)
               {
                MA3Buffer2[shift]=EMPTY_VALUE;
                MA3Buffer3[shift]=EMPTY_VALUE;
               }
        }
     }
     
//+++======================================================================+++
//+++======================================================================+++
   for(i=MA1ColorTime; i<Bars-(MA1ColorTime+1); i+=MA1ColorTime*3)
     {
      for(j=0, shift=i; j<(MA1ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA1Buffer2[shift] = iMA(NULL,0,MA1period,MA1shift,MA1metod,MA1price,shift);
            
        if (MA123Type == OpenClose)
            MA1Buffer2[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_OPEN,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA1Buffer2[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_LOW,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA1Buffer2[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_OPEN,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_LOW,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_HIGH,shift)) /4;
         
             if(j>0 && j<MA1ColorTime)
               {
                MA1Buffer1[shift]=EMPTY_VALUE;
                MA1Buffer3[shift]=EMPTY_VALUE;
               }
        }
     }
     
//+++======================================================================+++
   for(i=MA2ColorTime; i<Bars-(MA2ColorTime+1); i+=MA2ColorTime*3)
     {
      for(j=0, shift=i; j<(MA2ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA2Buffer2[shift] = iMA(NULL,0,MA2period,MA2shift,MA2metod,MA2price,shift);
            
        if (MA123Type == OpenClose)
            MA2Buffer2[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_OPEN,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA2Buffer2[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_LOW,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA2Buffer2[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_OPEN,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_LOW,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_HIGH,shift)) /4;
         
             if(j>0 && j<MA2ColorTime)
               {
                MA2Buffer1[shift]=EMPTY_VALUE;
                MA2Buffer3[shift]=EMPTY_VALUE;
               }
        }
     }
   
//+++======================================================================+++
   for(i=MA3ColorTime; i<Bars-(MA3ColorTime+1); i+=MA3ColorTime*3)
     {
      for(j=0, shift=i; j<(MA3ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA3Buffer2[shift] = iMA(NULL,0,MA3period,MA3shift,MA3metod,MA3price,shift);
            
        if (MA123Type == OpenClose)
            MA3Buffer2[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_OPEN,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA3Buffer2[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_LOW,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA3Buffer2[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_OPEN,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_LOW,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA3ColorTime)
               {
                MA3Buffer1[shift]=EMPTY_VALUE;
                MA3Buffer3[shift]=EMPTY_VALUE;
               }
        }
     }

//+++======================================================================+++
//+++======================================================================+++

   for(i=MA1ColorTime*2; i<Bars-1; i+=MA1ColorTime*3)
     {
      for(j=0, shift=i; j<(MA1ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA1Buffer3[shift] = iMA(NULL,0,MA1period,MA1shift,MA1metod,MA1price,shift);
            
        if (MA123Type == OpenClose)
            MA1Buffer3[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_OPEN,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA1Buffer3[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_LOW,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA1Buffer3[shift] = (iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_OPEN,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_LOW,shift) + iMA(NULL,0,MA1period,MA1shift,MA1metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA1ColorTime)
               {
                MA1Buffer1[shift]=EMPTY_VALUE;
                MA1Buffer2[shift]=EMPTY_VALUE;
               }
        }
     }

//+++======================================================================+++
   for(i=MA2ColorTime*2; i<Bars-1; i+=MA2ColorTime*3)
     {
      for(j=0, shift=i; j<(MA2ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA2Buffer3[shift] = iMA(NULL,0,MA2period,MA2shift,MA2metod,MA2price,shift);
            
        if (MA123Type == OpenClose)
            MA2Buffer3[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_OPEN,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA2Buffer3[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_LOW,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA2Buffer3[shift] = (iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_OPEN,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_LOW,shift) + iMA(NULL,0,MA2period,MA2shift,MA2metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA2ColorTime)
               {
                MA2Buffer1[shift]=EMPTY_VALUE;
                MA2Buffer2[shift]=EMPTY_VALUE;
               }
        }
     }
     
//+++======================================================================+++
   for(i=MA3ColorTime*2; i<Bars-1; i+=MA3ColorTime*3)
     {
      for(j=0, shift=i; j<(MA3ColorTime+1); j++, shift++)
        {
        if (MA123Type == Simple)
            MA3Buffer3[shift] = iMA(NULL,0,MA3period,MA3shift,MA3metod,MA3price,shift);
            
        if (MA123Type == OpenClose)
            MA3Buffer3[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_OPEN,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_CLOSE,shift)) /2;
            
        if (MA123Type == LowHigh)
            MA3Buffer3[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_LOW,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_HIGH,shift)) /2;
            
        if (MA123Type == HeikenAshi)
            MA3Buffer3[shift] = (iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_OPEN,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_CLOSE,shift) +
                iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_LOW,shift) + iMA(NULL,0,MA3period,MA3shift,MA3metod,PRICE_HIGH,shift)) /4;

             if(j>0 && j<MA3ColorTime)
               {
                MA3Buffer1[shift]=EMPTY_VALUE;
                MA3Buffer2[shift]=EMPTY_VALUE;
               }
        }
     }
     
//+++======================================================================+++
//+++======================================================================+++
   if(width1>SizeIndication1) width1=MA1size;   else width1++;
   
   SetIndexStyle(0,DRAW_LINE,MA1style,width1,MA1Clr1);   SetIndexStyle(1,DRAW_LINE,MA1style,width1,MA1Clr2);   SetIndexStyle(2,DRAW_LINE,MA1style,width1,MA1Clr3);
   SetIndexLabel(0, "MA1  ["+IntegerToString(MA1period)+ "] ");   SetIndexLabel(1, "MA1  ["+IntegerToString(MA1period)+ "] ");   SetIndexLabel(2, "MA1  ["+IntegerToString(MA1period)+ "] ");
   
//+++======================================================================+++
   if(width2>SizeIndication2) width2=MA2size;   else width2++;
   
   SetIndexStyle(3,DRAW_LINE,MA2style,width2,MA2Clr1);   SetIndexStyle(4,DRAW_LINE,MA2style,width2,MA2Clr2);   SetIndexStyle(5,DRAW_LINE,MA2style,width2,MA2Clr3);
   SetIndexLabel(3, "MA2  ["+IntegerToString(MA2period)+ "] ");   SetIndexLabel(4, "MA2  ["+IntegerToString(MA2period)+ "] ");   SetIndexLabel(5, "MA2  ["+IntegerToString(MA2period)+ "] ");
   
//+++======================================================================+++
   if(width3>SizeIndication3) width3=MA3size;   else width3++;
   
   SetIndexStyle(6,DRAW_LINE,MA3style,width3,MA3Clr1);   SetIndexStyle(7,DRAW_LINE,MA3style,width3,MA3Clr2);   SetIndexStyle(8,DRAW_LINE,MA3style,width3,MA3Clr3);
   SetIndexLabel(6, "MA3  ["+IntegerToString(MA3period)+ "] ");   SetIndexLabel(7, "MA3  ["+IntegerToString(MA3period)+ "] ");   SetIndexLabel(8, "MA3  ["+IntegerToString(MA3period)+ "] ");
   
//+++======================================================================+++
//+++======================================================================+++
     if (MA1period == -1 || MA1period == 0)     
     { SetIndexStyle(0, DRAW_NONE);   SetIndexStyle(1, DRAW_NONE);   SetIndexStyle(2, DRAW_NONE);   SetIndexLabel(0, NULL);   SetIndexLabel(1, NULL);   SetIndexLabel(2, NULL); }
     
     if (MA2period == -1 || MA2period == 0)     
     { SetIndexStyle(3, DRAW_NONE);   SetIndexStyle(4, DRAW_NONE);   SetIndexStyle(5, DRAW_NONE);   SetIndexLabel(3, NULL);   SetIndexLabel(4, NULL);   SetIndexLabel(5, NULL); }
     
     if (MA3period == -1 || MA3period == 0)     
     { SetIndexStyle(6, DRAW_NONE);   SetIndexStyle(7, DRAW_NONE);   SetIndexStyle(8, DRAW_NONE);   SetIndexLabel(6, NULL);   SetIndexLabel(7, NULL);   SetIndexLabel(8, NULL); }
     
//+++======================================================================+++
//+++======================================================================+++
   return(0);
  }
  
//+++======================================================================+++
//+++                     Moving Averages 3x3 Colors                       +++
//+++======================================================================+++

